
\section{Introduction and positioning} \label{introduction}

Within the context of cognitive computational neuroscience modeling, with both symbolic and numerical approaches, i.e., neurosymbolic artificial intelligence, we propose here an unusual way to relate explicit and readable data structure representing both the system state and its related meta-data with biologically plausible numeric operations.

To this end, we need to first position the proposed technical development with respect to brain modeling at a symbolic level, both in terms of paradigm, and in terms of knowledge representation, while also briefly reviewing existing approaches in order to position the originality of what is proposed here. This is going to be done in this section.

We must then define what we precisely mean by a ``symbolic'' approach for both the system state and its related meta-data, i.e., for both what is encoded in the neuronal ensembles and the modeling knowledge allowing us to explain and interpret it. To this end, in the next section, we revisit first what are signs and symbols, discussing the underlying concepts, and allowing us to share our design choices.

Based on this, the third section describes at the computational level, how the previous abstract data structure ingredients can be formalized, including at the programming level, allowing to consider generic numeric algorithms directly on the symbolic data structures and making explicit the formal requirements of distance and of a notion of region, equipped with a projector of a data point onto such a region.

The development related to the creation of a metrizable symbolic data structure embedded in a metric space, requires also the specification of a scalar field, using the notion of geodesic between two data and the notion of data region (i.e., data type or concept), which is postponed to the fourth section.

The final section discusses how rather generic machine learning algorithms can now be applied at both the symbolic and numerical level simultaneously to encounter for generic mechanism of open-ended or ill-defined complex problem solving, and reinforcement symbolic learning, before a short conclusion.

\vspace*{-0.05in} \subsection{Brain modeling at a symbolic level} \vspace*{-0.05in} \label{brain-symbolic}

Studying the brain is performed at different temporal and spatial scales, and also at different topological network scales, as illustrated in Fig.~\ref{neuroscales} from \cite{betzel_multi-scale_2016}. Their review shows that multi-scale topological structure modeling requires a qualitative symbolic description of e.g., the clusters or attractors, or what they called the ``communities'' hierarchy, in addition to qualitative properties (in the dynamic system theory sense). This means that the description requires a non-trivial symbolic data structure, and not only a numerical representation of the behavior. This is one aspect of the proposed work.

\begin{figure}[htbp] \begin{center}
    \includegraphics[width=0.7\textwidth]{./neuroscales.png}
  \end{center} \caption{Brain networks are organized across multiple spatiotemporal scales, and also at different topological network scales, from \cite{betzel_multi-scale_2016}, see text.}
\label{neuroscales}
\end{figure}

\vspace*{-0.05in} \subsubsection{From numeric to symbolic brain modeling} \vspace*{-0.05in} \label{modeling-scale}

There is another aspect of numerical versus symbolic modeling of the brain, considering a fourth, say, ``modeling'' scale, in the sense of Marr, as reviewed and questioned in \cite{hardcastle_marrs_2015}. The original Marr or Gibson frameworks (see \cite{glennerster_computational_2002} for a comprehensive review) were very fruitful, showing that cognitive processing, e.g., vision passes through a series of stages, each corresponding to a different representation, from neural input activity (e.g., a retinal image), to high-level symbolic representation (e.g., a 3D representation of a scene as objects). A key point of both theories was that contingent regularities in the physical environment, known by the system, explain how the visual system determines the shape and location of objects in the world on the basis of the retinal input. This generalizes to other sensorimotor skills. Such knowledge is to be represented as symbolic information. However, as pointed out in \cite{hardcastle_marrs_2015}, the notion of the computational stage has highly evolved with the progress in computational neuroscience. More than a final stage, the computational paradigm is at the core of the interaction between the so-called implementation and a more high-level behavioral stage, i.e., in link with a modeling scale (e.g., \cite{kitcher_marrs_1988}). This is sketched out in Fig.\ref{neuroparadigms}. At the difference of Marr's original three implementation, algorithmic and computational levels, we consider the implementation level, more precisely, as a biophysical representation in the wide sense, and consider as the highest level the cognitive behavior, while the computational stage, includes algorithmic aspects. This also allows us to clarify that the numerical, i.e., quantitative, aspects mainly stand on the biophysical side, while symbolic representation mainly stands on the behavioral stage, of course not exclusively, but more than a gradient. The key point is that computational representation must intrinsically be able to manage both representations conjointly. This corresponds to the development proposed here.
 
\begin{figure}[htbp] \begin{center}
    \includegraphics[width=0.8\textwidth]{./neuroparadigms.png}
  \end{center} \caption{A tentative to revisit the original Marr's cognitive stages, considering the recent computational neuroscience progress, allowing to clarify the numeric to symbolic gradient in both internal knowledge representation and related modeling, as discussed in the text: The top line reproduces the Marr's three levels, while the cognitive level is added because missing in the original description. Taking more recent studies into account, a different organization of this modeling dimension of brain description is sketched out in the lower part of the figure.}
\label{neuroparadigms}
\end{figure}

\vspace*{-0.05in} \subsubsection{From phenomenological to ontological brain modeling} \vspace*{-0.05in} \label{ontology-modeling}

Usually, the symbolic aspects of brain activity modeling are discussed at a phenomenological level, i.e., in a human-readable form, and the formalization is represented through block diagrams, showing the relations between model entities, each entity (e.g., a sensorimotor mechanism or a cognitive function) being defined via a key-word, a human-readable comment,  properties and relations with other entities. This is more or less an informal ontology (see \cite{cao_web_2014} for a general introduction and \cite{noy_ontology_2001} for a practical approach). A step further, the brain is modeled using such a well-established framework, as explained in \cite{gleeson_open_2019}, and made available on the \href{https://www.opensourcebrain.org}{Open Source Brain (OPS)} platform that gathers many projects together. The brain anatomy is already formalized from a rather long time, as, for instance, a \href{https://www.dbpedia.org}{DBpedia} resource (see \cite{dojchinovski_dbpedia_2021} for a presentation of this crowd-sourced community effort of extraction of structured information from various Wikimedia projects), while the OPS platform provides knowledge representation of microscopic (e.g., the Hodgkin-Huxley model) or mesoscopic (e.g., the neocortex cortical columns) models, while macroscopic cognitive models corresponds to work in progress: problem-solving tasks has been addressed \cite{carbonell_using_1997} focusing recently in computational thinking \cite{mercier_formalizing_2021} when engaged in a creative open problem-solving activity \cite{mercier_ontology_2022}; more generally  formalization of learning has been reviewed in \cite{stancin_ontologies_2020}, (e.g., in game based learning resources \cite{abou_elfotouh_serious_2017}), targeting adaptive learning \cite{cheung_ontology-based_2010}, in e-learning systems (see \cite{george_review_2019} for a review), including modeling the learner (see \cite{abyaa_learner_2019} for a review), and also to better formalized mental diseases \cite{hastings_representing_2012}. However, these are external descriptions of the brain and it would be interesting to also introduce such symbolic data representation in models simulating the brain behavior itself, as discussed now. 

\vspace*{-0.05in} \subsection{Neurosymbolic approaches} \label{neurosymbolic}

Numeric machine learning mechanisms, i.e. calculating, is mainly based on statistical inferences, including Bayesian inference, and has now reached outstanding performances. On the other hand, when manipulating knowledge, explicit symbolic machine learning mechanism, i.e. reasoning, is much more efficient to infer knowledge from known facts, and hybrid mechanisms seem mandatory for complex tasks where non-trivial a priori knowledge is to be introduced (see, e.g, \cite{de_penning_neural-symbolic_2011} for a realistic application). It has also great advantages when both interpretability (by an expert) and explainability (for end users) is a key feature, as discussed in \cite{chraibi_kaadoud_explaining_2022} in link with creativity. These features are essential if such learning mechanisms are used to model cognitive functions. In addition, formal reasoning is by no means less costly than billions of operations of deep networks computation, as studied by \cite{desislavov_compute_2023}, which limit their academic use for usual research teams, beyond raised ecologic and ethical issues, discussed by the authors. The use of such ``black-box'' tools at the modeling level is also questionable as analyzed in \cite{schaeffer_no_2022}.

Coupling both approaches should bring the required computational power to solve complex problems or model complex brain functions, in an explainable way, and with parsimonious resources consumption, and neural-symbolic computing brings together robust learning in neural networks with reasoning and explainability via symbolic representations as recently reviewed in details in \cite{garcez_neurosymbolic_2023}. It is an active area of research for many years and the author's detailed analysis considers different coupling levels:
\\ -  Type 1: {\em standard numeric computation with symbolic input/output} (e.g., word2vec nicely introduced in \cite{rong_word2vec_2016}). In this class of method, symbolic input is embedded in a numerical space that is able to encounter the pertinent relation between the input symbols\footnote{More precisely, for word2vec, text words are considered within a small segment of text, embedded in a huge trivial dimensional space (one dimension by input) to be reduced by cross-entropy between input and output distribution optimization to a hidden encoding layer regenerating the output as in usual auto-encoder architecture}. The symbolic processing is devoted to, e.g., a deep neural network in which output units feed a softmax (sometimes hierarchical) mechanism attributing a kind of probability to each expected symbol.
\\ - Type 2,3: {\em hybrid systems with symbolic and numeric modules interaction} (e.g., the well-known DeepMind's, AlphaGo or ChatPGT) corresponds to loosely-coupled neural network with a symbolic problem solver up to more sophisticated interactions between both systems.
\\ - Type 4,5: {\em symbolic knowledge and rules are compiled in distributed calculation} (e.g. Vector Symbolic Architectures (VSA) \cite{eliasmith_how_2013}) either using localist mapping of symbols or more complex embedding of symbolic rules, in both cases symbolic knowledge is translated into the network architecture and parameters. Relevant examples stand from localist logical neural networks \cite{riegel_logical_2020} to logic tensor network \cite{serafini_logic_2016}.
\\ In addition a type 6 is evoked as a perspective on ongoing research\footnote{This layer is described as able to solve high cognitive functions, like attention schema, with the hope of being able to perform efficient combinatory reasoning (i.e., find approximate solutions to NP-hard problems by hybrid, de facto polynomial systems). This last point corresponds to existing algorithms as for instance reviewed in \cite{paschos_overview_2007}.}. The present work precisely aims at considering type 4 or 5 coupling levels.

One motivation for such an approach is explainability, as reviewed by \cite{burkart_survey_2021} in the domain of supervised learning, with both the capability to interpret both results and reasoning path, but also, as mentioned by the authors, to be able to introduce high-level explicit a-priory knowledge which allows to better constraint the system, thus provide more efficient results. This may be another interest of the present approach. Being able to work at both the numeric and symbolic level is well illustrated, in link with focusing on problem-solving as done here, by \cite{vasileiou_logic-based_2022} discussing a logic based explanation mechanism in planning, dedicated to controlled hybrid systems in human interaction. This efficient approach of the authors specify the symbolic layer ``outside'' the related numeric representation, while at a more basic but better integrated level, such plan is represented by the notion of abstract path, as developed in this paper. Link between symbolic and numeric approaches when considering domain-independent planners is also well illustrated in \cite{asai_classical_2022} and we wonder if our data representation could not be an interesting tool, for such an architecture. This work is also in link with ontology related reasoning as, for instance in \cite{hohenecker_ontology_2020} for which the symbols are optimally encoded in the network numeric variables. Here as a dual approach, numeric elements cover symbolic data in our case. The link between our representation and ontology approaches is also detailed here. 

Further technical elements about symbolic versus numeric representation are discussed in Appendix~\ref{symbonumerication}.

\vspace*{-0.05in} \subsubsection{Neuro-symbolic brain modeling} \vspace*{-0.05in} \label{neurosymbolic-modeling}

A key point is that, up to our best knowledge, computational neuroscience models are mainly based on either Type 1 mechanisms, like encoders, with the epistemological issues at the modeling level, evoked before, and quite exceptionally Type 2,3 (e.g., \cite{spens_generative_2023} that study to what the GPT model used in ChatGPT can encounter for hippocampus replay training neocortical generative models, although it is not clear about is learned by such a general-purpose model regarding the hippocampus specificity, while such approach is far from being refutable\footnote{We make here a distinction between the historic notion of falsifiability and refutability, see \cite{olszewski_falsifiability_2011} and \cite{cartwright_how_1983} for a wider epistemological discussion on modeling.}), while the Type 5 VSA architecture (after \cite{eliasmith_how_2013}) based on Semantic Pointer Architecture (SPA) introduces an intermediate algebraic abstract view of spiking neural network architectures, in order to develop biologically plausible cognitive functionalities, and human knowledge representations \cite{crawford_biologically_2016}, including high-level symbolic representation allowing reasoning \cite{mercier_ontology_2021}, including regarding not only deductive but also inductive and abducting reasoning, as discussed in \cite{mercier_where_2023}.

As a complementary approach, to the previous works, we are not going to study how to embed a symbolic representation onto a given numeric space, but how to equip directly the symbolic data structure with the numeric ingredients needed to apply numeric algorithms, and show how general algorithms can be applied directly on the symbolic data structure by this mean. To this end, in the next section let us precisely state what is a ``symbolic representation'', in order to make explicit our design choices to represent cognitive symbolic information.

\paragraph{On slow versus fast thinking}~\\

A step further, considering information processing, this distinction between numerical and symbolic information is associated to the notion of fast and slow thinking popularized by \cite{kahneman_thinking_2011} and revisited in the double perspective of human and machine computation \cite{bonnefon_machine_2020} and cognitive functions \cite{shleifer_psychologists_2012}. In a nutshell, "fast" thinking corresponds to numerical calculation, e.g. deep-learning, at the cognitive level it operates automatically, intuitively, involuntarily, and effortlessly. This involves our procedural memory for habitual behavior (e.g., driving a car) or memory recall (either episodic or semantic), or basic perceptual tasks (e.g., recognizing an object). This computational mode can be interpreted at a symbolic level (e.g., associating symbols to state configurations), but seems to be mainly numeric. On the other hand, "slow" thinking is associated with symbolic reasoning, e.g, a first-order logic reasoner, and corresponds to cognitive processes that require slowing down, deliberating, solving problems, reasoning, computing, focusing, concentrating, considering other data, and so on. It is mainly associated to symbolic information, although, in our brain, it is also implemented at the neuronal coding and processing level, which modeling is nowadays involving numerical calculi, but with the key idea that it is understandable and interpretable only at a more symbolic level, beyond molecular chemical reactions, or neuronal network dynamic. This dual presentation has been discussed in more detail in \cite{romero_deciphering_2023} with the interesting conclusion that modeling fast thinking also requires symbolic information. Our proposal thus applies to both aspects of a cognitive system.
